/*-
 * %%----------------------------------------------------------------------------------------------
 * Solidify Framework - Solidify Frontend - data-table-bulk-actions.model.ts
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2023 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

import {ElementRef} from "@angular/core";
import {Observable} from "rxjs";
import {BaseResource} from "../dto/base-resource.model";
import {ExtraButtonToolbar} from "./extra-button-toolbar.model";

export interface DataTableBulkActions<TResource extends BaseResource> extends ExtraButtonToolbar<TResource[] | any> {
  callback?: (current?: TResource[] | undefined, buttonElementRef?: ElementRef | undefined, checked?: boolean) => Observable<boolean> | void;
}
